import 'dart:convert';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:http/http.dart';
import 'package:test_sa/controllers/api_routes/api_manager.dart';
import 'package:test_sa/controllers/api_routes/urls.dart';
import 'package:test_sa/models/service_request/search_work_order.dart';

class VendorProvider extends ChangeNotifier {
  void reset() {
    _vendors = null;
    _loading = null;
    _stateCode = null;
  }

  int _stateCode;
  int get stateCode => _stateCode;

  List<Supplier> _vendors;
  List<Supplier> get vendors => _vendors;

  bool _loading;
  bool get isLoading => _loading;
  set isLoading(bool isLoading) {
    _loading = isLoading;
    notifyListeners();
  }

  Future<int> getVendors(String text) async {
    if (_loading == true) return -2;
    _loading = true;
    notifyListeners();
    Response response;
    try {
      response = await ApiManager.instance.get("${URLs.getSuppliersAutoComplete}?searchText=$text");
      _stateCode = response.statusCode;
      if (response.statusCode >= 200 && response.statusCode < 300) {
        // client's request was successfully received
        List suppliersJson = json.decode(response.body)["data"];
        _vendors = suppliersJson.map((type) => Supplier.fromJson(type)).toList();
      }
      _loading = false;
      notifyListeners();
      return response.statusCode;
    } catch (error) {
      _loading = false;
      _stateCode = -1;
      notifyListeners();
      return -1;
    }
  }
}
